import sys

import sir_stable
import vanhcalc
import meersoncalc
#include "randomrewrite.pyx"
include "sweeptroughfull.pyx"
#include "randthensweep.pyx"
#include "randthenexact.pyx"
include "sweepexactfull.pyx"
include "sirrandoms.pyx"
include "markovfull.pyx"

y = 1.0
I0 = 1
monitor_S = 1
Nfixed = 0

ip = open("samples.txt", "r")
for line in ip.readlines():
    words = line.split()
    if len(words) and words[0][0]!="#":
        N = int(words[0])
        BN = float(words[1])
        #if N!=30000 or BN < 7.9:
        #    continue
        for i in range(2, len(words)):
            if i==2:
                p0nom = 0.9
            elif i==3:
                p0nom = 0.5
            elif i==4:
                p0nom = 0.1
            elif i==5:
                p0nom = 0.1
            elif i==6:
                p0nom = 0.001
            u = float(words[i])
            ui = u
            condstr = "%d_%g_%g_%g_%d_%d_%d" % (N, BN, y, u, I0, Nfixed, monitor_S)
            sys.stdout.write(condstr + "\t")
            (Sd, Id) = sir_stable.stable(N, BN, y, u, ui)
            (Se, Ie) = sir_stable.stable_float(N, BN, y, u, ui)
            if Id <= 2:
                sys.stdout.write("Ie=%g, cannot do sensible first trough calculation\n" % Ie)
            else:
                #sys.stdout.write("Ie = %d\n" % Ie)
                Iupper2 = min( 2*Id, N)
                # It'd be nice to do this, but it turns the run time from seconds to minutes
                #sdpeaks = sirdetpeaks.sirdetpeaks(N=N, BN=BN, y=y, u=u, ui=ui, I0=I0, Nfixed=Nfixed)
                #(Smin, Imin) = sdpeaks[1][:2]
                #sys.stdout.write("Imin / Ie = %.3f = %.1f / %.1f\n" % (Imin/Ie, Imin, Ie))
                vanhcalc.calc(ofile="results/vanh_" + condstr + ".res",
                              N=N, BN=BN, y=y, u=u, I0=I0,
                              verbose=1, monitor_S=monitor_S, Nfixed=Nfixed, timeit=1)
                meersoncalc.wkb_calc(ofile="results/meerson_" + condstr + ".res",
                                     N=N, BN=BN, y=y, u=u, I0=I0,
                                     verbose=1, monitor_S=monitor_S, Nfixed=Nfixed, timeit=1)
                sdtarget = 0.001
                runs = int(p0nom * (1-p0nom) / sdtarget**2)
                if N < 100000:
                    timelimit = 2*3600
                else:
                    timelimit = 6*3600
                # for debug
                timelimit = 60
                #if 0: # only for future work
                #    sys.stdout.write("RnAppx ")
                #    randthensweep(N, BN, y, u, ui, I0, Sd, Id, Iupper2, Nfixed=Nfixed, monitor_S=monitor_S)
                #    sys.stdout.write("RnExact ")
                #    randthenexact(N, BN, y, u, ui, I0, Sd, Id, Iupper2, Nfixed=Nfixed, monitor_S=monitor_S)
                if 1:
                    sys.stdout.write("DiffAppx ")
                    sweeptroughfull(N, BN, y, u, ui, I0, Sd, Id, Iupper2, Nfixed=Nfixed, monitor_S=monitor_S)
                if N <= 100000:
                    sys.stdout.write("DiffExact ")
                    sweepexactfull(N, BN, y, u, ui, I0, Sd, Id, Iupper2, Nfixed=Nfixed, monitor_S=monitor_S)
                if 1:
                    sys.stdout.write("Rand ")
                    random2bounds("results/randomfull_" + condstr + ".res",
                                  N=N, BN=BN, y=y, u=u, ui=ui,
                                  Nfixed=Nfixed,
                                  startdict={ (N-I0,I0) : 1.0},
                                  Sd=Sd, Iupper=Id, Iupper2=Iupper2, from_start=1,
                                  monitor_S=monitor_S,
                                  runs=runs, verbose=1, timeit=True, timelimit=timelimit, png="")
                if N <= 3000:
                    sys.stdout.write("Exact ")
                    markovfull("results/markovfull_" + condstr + ".res",
                               N, BN, y, u, ui, I0, Sd, Id, Iupper2,
                               Nfixed=Nfixed, phase_method=1, timeit=1, verbose=1)
                sys.stdout.write("\n")
                # *** uncomment this like to run the lot
                sys.exit(0)
            
ip.close()
