# Attempted generic cython caller.
# Usage: python cyrun.py <cython_file_name>.pyx
# This version (except comments) 19-12-2014

import sys
import os
import imp

##### compile (only happens if required)

fname = sys.argv[1]
if fname.count(".py"):
    fname = fname.replace(".pyx", "")
    fname = fname.replace(".py", "")

compname = fname + "_compile"

c = open(compname + ".py", "w")
c.write("from distutils.core import setup\n")
c.write("from Cython.Build import cythonize\n")
c.write("import numpy as np\n")

# using np.get_include (and import np) as advised at http://stackoverflow.com/questions/2379898/make-distutils-look-for-numpy-header-files-in-the-correct-place
c.write('setup( include_dirs = [np.get_include()],\n')
c.write('       ext_modules = cythonize("%s.pyx")\n' % fname)
c.write('     )\n')
c.close()

#os.system('CFLAGS="" python %s.py build_ext --inplace > %s.log 2>&1' % (compname, compname))
status = os.system('python %s.py build_ext --inplace > %s.log 2>&1' % (compname, compname))
if status:
    sys.stderr.write("cython compiled failed, see %s.log\n" % compname)
    sys.exit(status)
    
##### run

fp, pathname, description = imp.find_module(fname)
imp.load_module(fname, fp, pathname, description)
