import sys
import random

# probdict: keys are states (in our case (S,I) tuples), values are probs
def dump(dict, tol=1e-6):
    keys = dict.keys()
    keys.sort() # shouldn't be needed
    list = []
    for key in keys:
        if dict[key] >= tol:
            list.append("p(%s) = %.6f\n" % (key, dict[key]))
    return "".join(list)

# check valid, i.e. all values non-neg, and sum to 1
def check(dict, verbose=1, tol=1e-6):
    sum = 0.0
    good = 1
    for key in dict.keys():
        if dict[key] < 0.0:
            sys.stdout.write("*** WARNING dict[%s] = %g < 0\n" % (key, dict[key]))
            good = 0
        sum += dict[key]
    if abs(sum - 1.0) > tol:
        if verbose:
            sys.stdout.write("*** WARNING total prob in dict = %g\n" % sum)
        good = 0
    return good

# sum of all values is 1 (i.e. a prob dist)
# choose one according its prob
def sample(dict):
    keys = dict.keys()
    #keys.sort() # shouldn't be needed
    x = random.random()
    sum = 0.0
    for key in keys:
        sum += dict[key]
        # random.random() generates number on [0,1), so test with <
        if sum > x:
            return key
    else:
        #raise Exception, "sample_probdict ran out of keys"
        sys.stdout.write("*** WARNING sample_probdict ran out of keys, using %s\n" % keys[-1])
        return keys[-1]
