import math

def stable_float(N, BN, y, u, ui):
    B = BN / float(N)
    Se = (y + ui) / float(B)
    Ie = N * (BN-y-ui)*u / float(BN*(y+u))
    return (Se, Ie)

def stable(N, BN, y, u, ui):
    (Sfloat, Ifloat) = stable_float(N, BN, y, u, ui)
    # S_stable: round up, test for < (not <=)
    # I_stable: round up, test for < (not <=)
    Se = int(math.ceil(Sfloat) + 0.1)
    Ie = int(math.ceil(Ifloat) + 0.1)
    return (Se, Ie)


