# Frank Ball's approximation

import sys
import math
import scipy.special

def ball(N, B, y, u1, S0, I0, verbose):
    a = B - y - u1
    b = B * (N-S0) / float(N)
    gamln = scipy.special.gammaln(a/u1 - 1) + math.log(scipy.special.gammainc(a/u1 - 1, b/u1))
    part1ln = math.log(y+u1)
    part2ln = b/u1 - math.log(b)
    part3ln = (a/u1 - 1) * math.log(u1/b)
    J = math.exp(part1ln + part2ln + part3ln + gamln)
    p0 = (J / (1 + J)) ** I0
    if verbose >= 2:
        sys.stdout.write("ball(%d, %g, %g, %g, %d, %d), a=%g, b=%g, part1=%g, part2=%g, part3=%g, gam=%g, J=%g, p0=%g\n"
                         % (N, B, y, u1, S0, I0, a, b, math.exp(part1ln), math.exp(part2ln), math.exp(part3ln), math.exp(gamln), J, p0))
    return p0
