import sys
import matplotlib.pyplot as plt

LOG = 0

colors = ["b", "g", "r", "c", "m"]

if len(sys.argv) > 1:
    ip = open(sys.argv[1], "r")
else:
    ip = open("switchpoint_runs.ures", "r")

#xvals = []
#dict = {}
#plots = 0
#xmax = 0

N = "30000"
y = "1"
u1 = "0.025"
B1 = 3
sticky = "1"

lists = {}

for line in ip.readlines():
    words = line.replace(",", " ").split()
    if len(words) and words[0]=="p0" and words[1]=="=" and words.count("sticky=%s" % sticky):
        for word in words:
            if word.find(N)==0:
                parts = word.split("_")
                if parts[1]==("%g" % B1) and parts[3]==y and parts[4]==u1:
                    B2 = float(parts[2])
                    Bpercent = int(100 * B2 / B1 + 0.5)
                    if Bpercent not in lists:
                        lists[Bpercent] = [None, None, None, None, None, None]
                    nameshort = r"$\beta^{(2)}/\beta^{(1)}=%s$" % (B2/B1)
                    p0 = float(words[2])
                    if line.count("for always B2"):
                        lists[Bpercent][0] = p0
                    elif line.count("for switch at B"):
                        lists[Bpercent][1] = p0
                    elif line.count("for simplified policy"):
                        lists[Bpercent][2] = p0
                    elif line.count("for switch at C"):
                        lists[Bpercent][3] = p0
                    elif line.count("for switch at D"):
                        lists[Bpercent][4] = p0
                    elif line.count("for always B1"):
                        lists[Bpercent][5] = p0
                    else:
                        raise Exception, "unknown point in line:\n" + line
                else:
                    sys.stdout.write("Ignoring line [%s, %s, %s]: %s " % (parts[1], parts[3], parts[4], line))
                break
        else: # for - else
            raise Exception, "no word beginning '%s' in line:\n%s%s" % (N, line, words)
ip.close()

plt.clf()
#plt.figure(figsize=(8,3.5))
plt.rc('font',**{'family':'serif','serif':['Computer Modern Roman']})
plt.rc('text', usetex=True)

keys = lists.keys()
keys.sort()
keys.reverse()
sys.stdout.write("%d lists created\n" % len(keys))
for key in keys:
    sys.stdout.write("%s: %s\n" % (key, lists[key]))
markers = ["o", "o", "^", "v", "s", "*"]
marker = 0
for key in keys:
    if markers[marker]=="*":
        markersize = 9
    else:
        markersize = 6
    if marker==0:
        fillstyle = "none"
    else:
        fillstyle = "full"    
    plt.plot([1,2,3,4,5,6], lists[key],
             label=r"$\beta^{(2)}/\beta^{(1)}=%g$" % (key / 100.0),
             marker=markers[marker], linestyle=":", #color=colors[marker], 
             markersize=markersize, fillstyle=fillstyle)
    marker += 1
prefix = ""
#plt.title(prefix + r"$p_0$ at different switch points, $N=%s$, $\beta^{(1)}=%s$, $\mu=%s$, $\gamma=1$" % (N, B1, u1))
#plt.title(prefix + r"$p_0$ at different switch points")
plt.ylabel(r"$p_0$", rotation="horizontal", fontsize="large")
#plt.xlabel(r"1=$\beta^{(1)}$, 10=$\beta^{(2)}$, 3=peak, 5=quickcalc, 6=MDP, 7=($I=I_d$), etc")
plt.xlabel("")
#plt.xlim(xmin=0, xmax=5)
plt.ylim(ymin=0, ymax=1.05) #1.4)
plt.yticks([0, 0.2, 0.4, 0.6, 0.8, 1], fontsize="large")
plt.xticks([0.8] + range(1,7) + [6.2] , ["", "A", "B", "*", "C", "D", "E", ""], fontsize="large")
plt.legend(loc="lower left", ncol=2, fontsize="large")
plt.savefig("p0_switchpoints.png")
plt.savefig("p0_switchpoints.pdf")
