import sys

import sirdefs
import sirdetpeaks
import sweeptroughfull

N = 30000
u2 = 0
u3 = 0
y = 1
I0 = 1
S0 = N - I0

#Bs = [1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.8, 2, 2.2, 2.5, 3, 3.5, 4]
Bs = [3] #[3, 2, 4] # only do one beta for this plot
betamods = [1.0, 0.95, 0.9, 0.8, 0.7, 0.6]

# for testing
#Bs = [3]
#betamods = [0.8, 0.7, 0.6]
verbose = 0

# just like det_performance_calc.py but with sticky

for stickyswitch in [1]: # [1, 0]
    for B1 in Bs:
        for u1 in [0.025]:
            for betamod in betamods:
                B2 = B1 * betamod
                if B2 > y + u1:
                    # do sticky also?
                    filename = "%d_%g_%g_%g_%g_%g_%g_%d" % (N, B1, B2, y, u1, u2, u3, I0)
                    (Se1, Ie1) = sirdefs.stable_float(N, B1, y, u1, u2, u3)
                    (Sd1, Id1) = sirdefs.stable(      N, B1, y, u1, u2, u3)
                    (Se, Ie)   = sirdefs.stable_float(N, B2, y, u1, u2, u3)
                    (Sd, Id)   = sirdefs.stable(      N, B2, y, u1, u2, u3)
                    Ipolicytop = sirdefs.get_Ipolicytop(N, y, u1, u2)
                    Iupper2 = sirdefs.get_Iupper2(N, y, u1, u2)
                    sys.stdout.write("(Se1,Ie1)=(%.1f,%.1f), (Se,Ie)=(%.1f,%.1f)\n" % (Se1, Ie1, Se, Ie))
                    for (Sx, Ix, diffswitchcond, comment) in [
                        ((0, N), (N, N), "1",  "always B2"), # always switch
                        ((0, N), (N, N), "s<%g" % (Se1/float(N)), "switch at B"), # switch at Imax (S<=Sd1)
                        ((0,          Sd1, max(Sd1+1,Sd-1), max(Sd1+1,Sd-1)+1, N),
                         (Ipolicytop, Id1, Id1,             Id,                Id), "", "simplified policy"), # switch at det point
                        ((0, N), (Id1, Id1), "0", "switch at C"), # switch at I=Id falling (Id1)
                        ((0, Sd1-1, Sd1, N), (0, 0, Id, Id), "0", "switch at D"), # switch at S>Sd in trough
                        ((0, N), (0, 0), "0", "always B1"), # never switch
                        ]:
                        if comment=="always B2":
                            (S1, I1, tignore) = sirdetpeaks.detpoint(N=N, BN=B2, y=y, u1=u1, u2=u2, u3=u3, I0=I0, S0=S0,
                                                                     point=1, forceint=True)
                            this_B1 = B2
                            this_betamod = 1.0
                        else:
                            (S1, I1) = (S0, I0)
                            this_B1 = B1
                            this_betamod = betamod
                        p0 = sweeptroughfull.sweeptroughfull("",
                                                             N, this_B1, y, u1, u2, u3, I1,
                                                             #Sd, Id, Iupper2,
                                                             #Istart=Istart,
                                                             monitor_S=1, S0=S1,
                                                             Sx=Sx, Ix=Ix, Ixb=0, diffswitchcond=diffswitchcond,
                                                             switchset=set(), switch_ABC=[],
                                                             stickyswitch=stickyswitch,
                                                             betamod=this_betamod,
                                                             verbose=verbose)
                        #(escapes, outbreaks) = sirrandoms.random2bounds("",
                        #                                                N=N, BN=B1, y=y, u1=u1, u2=u2, u3=u3,
                        #                                                startdict={(S0,I0) : 1.0},
                        #                                                Ilower=0, Sd=Sd, Iupper=Id, Iupper2=Iupper2, from_start=1,
                        #                                                Sd1=Sd1, Id1=Id1, stickyswitch=stickyswitch,
                        #                                                runs=10000, verbose=verbose, timeit=1, timelimit=10*60,
                        #                                                Sxl=-1, Sxr=-1, Ixl=-1, Ixr=-1, Ixb=-1, betamod=betamod,
                        #                                                policy=set(), all1=0, detpolicy=detpolicy, switchpoint=switchpoint,
                        #                                                )
                        sys.stdout.write("p0 = %s for %s, %s, sticky=%d, sweeptrough\n\n" % (repr(p0), comment, filename, stickyswitch))
